/***************************************************************************/
/*** ERMA-Electronic GmbH, Max-Eyth-Str. 8, 78194 Immendingen            ***/
/*** Telefon: 07462/7381, Fax: 07462/7554                                ***/
/*** Programmname: FR1215Z.C                                             ***/
/*** Testprogramm fr die PC-Karte FR 1215 als Zhler                    ***/
/*** Programmiersprache: Turbo C++ Version 3.0                           ***/
/***************************************************************************/

#include <stdio.h>
#include <dos.h>
#include <conio.h>

void Bildschirm();
void Initialisieren();	/*Zhlerbausteine initialisieren*/
void Nullsetzen();		/*Zhler auf Null setzen*/
void Lesen();			/*Zhlerstand einlesen und anzeigen*/

//Basisadresse der Karte 0x100
//Basisadresse Zhlerbaustein 1 0x100
//Basisadresse Zhlerbaustein 2 0x104
//Basisadresse Zhlerbaustein 3 0x108
//Basisadresse Zhlerbaustein 4 0x10C
int adresse[4]={0x100,0x104,0x108,0x10C};

//Hauptprogramm
void main()
{
	char ch;			//Tastenbettigung
	int Ende=0;			//Flag fr Programmende

	Bildschirm();		//Bildschirm aufbauen
	Initialisieren();	//Zhlerbausteine initialisieren
	Nullsetzen();		//Zhler Null setzen
	do
	{
		if (kbhit())    //Tastenbettigung ermitteln
		{
			ch=getch();
			if (ch=='0')	//Taste '0' = Zhlerbausteine Null setzen
			{
				Nullsetzen();
			}
			else
			{
				Ende=1;		//andere Taste = Programmende
			}
		}
		Lesen();			//Zhlerstnde einlesen und anzeigen
	}while (!Ende);			//Abfrage Programmende
	clrscr();
}

//Bildschirmmaske aufbauen
void Bildschirm()
{
	int k,j;

	clrscr();
	gotoxy(31,3);
	cprintf("Zhlerprfprogramm");
	gotoxy(16,4);
	printf("------------------------------------------------");
	for (k=0;k<=3;k++)
	{
		for (j=0;j<=2;j++)
		{
			gotoxy(20,6+3*k+j);
			cprintf("Zhler Nr. ");
			cprintf("%2d", k*10+j);
			cprintf("           Wert = ");
		}
	}
	gotoxy(16,19);
	printf("------------------------------------------------");
	gotoxy(16,20);
	printf("Taste 0 = Zhler 0              Leertaste = Ende\n\n");
	printf("    -------> Achtung: 1.Flanke High/Low bernimmt den geladenen Zhlerzustand\n");
	printf("     Dieser Impuls fehlt im Ergebnis. Die nchsten Flanken High/Low zhlen.\n");
	printf("            Abhilfe: Laden mit Wert+1 oder beim Ergebnis +1 addieren");
}

//Zhlerbausteine Initialisieren
void Initialisieren()
{
	int k;

	for (k=0;k<=3;k++)
	{
		//Zhler 0 des Zhlerbausteins k = Mode 0
		outportb(adresse[k]+3,0x30);
		//Zhler 0 des Zhlerbausteins k mit Null beschreiben
		outportb(adresse[k],0x00);
		outportb(adresse[k],0x00);
		//Zhler 1 des Zhlerbausteins k = Mode 0
		outportb(adresse[k]+3,0x70);
		//Zhler 1 des Zhlerbausteins k mit Null beschreiben
		outportb(adresse[k]+1,0x00);
		outportb(adresse[k]+1,0x00);
		//Zhler 2 des Zhlerbausteins k = Mode 0
		outportb(adresse[k]+3,0xB0);
		//Zhler 2 des Zhlerbausteins k mit Null beschreiben
		outportb(adresse[k]+2,0x00);
		outportb(adresse[k]+2,0x00);
	}
}

//Zhler Nullsetzen
void Nullsetzen()
{
	int k,i;

	for (k=0;k<=3;k++)
	{
		for (i=0;i<=2;i++)
		{
			// alle Zhler mit Maximalwert 0xFF beschreiben
			outportb(adresse[k]+i,0xFF);
			outportb(adresse[k]+i,0xFF);
		}
	}
}

// Zhlerstnde einlesen and anzeigen
void Lesen()
{
	unsigned int A;
	unsigned int B;
	int k,j,i;
	unsigned int IZ[4] [3];

	for (k=0;k<=3;k++)
	{
		//Counter Latch Command Zhler 0 des Zhlerbausteins k
		outportb(adresse[k]+3,0x00);
		//Counter Latch Command Zhler 1 des Zhlerbausteins k
		outportb(adresse[k]+3,0x40);
		//Counter Latch Command Zhler 2 des Zhlerbausteins k
		outportb(adresse[k]+3,0x80);
	}
	for (k=0;k<=3;k++)
	{
		for (i=0;i<=2;i++)
		{
			//Zhlerstand einlesen
			A=inportb(adresse[k]+i); B=inportb(adresse[k]+i);
			//Zhlerstand  komplementieren, da Zhler abwrts zhlt
			A=A ^ 255; B=B ^ 255;
			IZ[k] [i]=A+256*B;
			//Zhlerstand anzeigen
			gotoxy(55,6+3*k+i);
			cprintf("%5u", IZ[k] [i]);
		}
	}
}